// #include"dp.h"
//edited by Hongyi on 10th September 2013
// test yices encoding
//! orignal from SRI yices C API example
// test yices increamental pop push 

#include<stdio.h>
#include"yices_c.h"
#include"yicesl_c.h"

void display(yicesl_context ctx) {
  if (yicesl_inconsistent(ctx)) 
    printf("unsatisfiable\n"); 
  else
    printf("satisfiable\n");
}



// new undocumented function/hack
extern yicesl_context yices_get_lite_context(yices_context ctx);

int main() {
  yices_context ctx = yices_mk_context();
  yicesl_context hidden = yices_get_lite_context(ctx);

  yices_push(ctx);

  yices_type ty  = yices_mk_type(ctx, "nat");
  yices_type domain[1];
  domain[0] = ty;
  yices_type gty = yices_mk_function_type(ctx, domain, 1, ty);
  yices_var_decl gdecl = yices_mk_var_decl(ctx, "g", gty);
  yices_expr     g     = yices_mk_var_from_decl(ctx, gdecl);

  yices_var_decl fdecl = yices_mk_var_decl(ctx, "f", gty);
  yices_expr     f     = yices_mk_var_from_decl(ctx, fdecl);

  yices_var_decl xdecl = yices_mk_var_decl(ctx, "x", ty);
  yices_var_decl ydecl = yices_mk_var_decl(ctx, "y", ty);

  /*
  yices_expr     x     = yices_mk_var_from_decl(ctx, xdecl);
  yices_expr     y     = yices_mk_var_from_decl(ctx, ydecl);

  yices_expr args[1];
  args[0] = x;
  yices_expr     fx    = yices_mk_app(ctx, f, args, 1);
  */

  printf("0: here\n");

  // yicesl_read(hidden, "(assert (= x y))");
  // yicesl_read(hidden, "(assert (= (update g (f x) x) (update g (f y) y)))");
  yicesl_read(hidden, "(assert (= (update g ((f x)) x) (update g ((f x)) y)))");


  printf("1: here\n");
  // yices_dump_context (ctx);

  yices_check(ctx);
  yices_model m = yices_get_model(ctx);
  yices_display_model(m);

  /*
  yices_expr args[1] = {yices_mk_num(ctx, 1)};
  yices_expr     fx    = yices_mk_app(ctx, f, args, 1);

  printf("3: here\n");

  yices_assert(ctx, yices_mk_eq(ctx, fx, yices_mk_num(ctx, 1)));

  switch (yices_check(ctx)) {
  case l_true:
    printf("---> sat\n");
    yices_model model = yices_get_model(ctx);
    yices_var_decl xdcl = yices_get_var_decl_from_name(ctx, "x");
    long value;
    if (xdcl == NULL) {
      printf("---> can't find declaration of x\n");
    } else if (yices_get_int_value(model, xdcl, &value)) {
      printf("---> x = %ld\n", value);
    } else {
      printf("---> can't find value of x in model\n");
    }
    break;
  case l_undef:
    printf("---> unknown\n");
    break;
  case l_false:
    printf("---> unsat\n");
    break;
  }
  */

  yices_pop(ctx);

  yices_del_context(ctx);

  return 0;
}
