#include <stdio.h>
#include "mpi.h"
#include "omp.h"


int main(int argc, char *argv[]) {
  int numprocs, rank, namelen;
  char processor_name[20];
  int iam = 0, np = 1;
  int j = 0;
  int i = 0;
  int stat = 0;
  int a =0 ;
  int b = 0;
  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &numprocs);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
 // MPI_Get_processor_name(processor_name, &namelen);
 // int j =0;
 //  int i = 0;
 //   int stat = 0;
 omp_set_num_threads(2);
//#pragma omp  for private(i)
 //for(j = 0; j < 2; j++)
  {
    if(rank==1 && (j==0))
    {
      for(i = 0; i < 3; i++)
       {
         a = 2;
         MPI_Send(&a, 1, MPI_INT, 1, 0, MPI_COMM_WORLD);
         printf("send to 0 in %d on 1\n",  omp_get_thread_num());
       
      } 
      
      for(i = 0; i < 3; i++)
      {
         MPI_Recv(&a, 1, MPI_INT, 1, 0,MPI_COMM_WORLD, MPI_STATUS_IGNORE);
         printf("recev from  0 in %d on 1\n",  omp_get_thread_num());
         
      }
    }
   if( rank==0 &&  (j ==0))
   {
       for(i = 0; i < 3; i++)
       {   
         MPI_Recv(&a, 1, MPI_INT, 1, 0, MPI_COMM_WORLD,MPI_STATUS_IGNORE);
         printf("recev from  1 in %d on 0\n",  omp_get_thread_num());
       }
      for(i = 0; i < 3; i++)
      {
           MPI_Send(&a, 1, MPI_INT, 1, 0,MPI_COMM_WORLD);
           printf("send to 1 in %d on 0\n",  omp_get_thread_num());
      }
   }

    if(rank==1 && (j==1))
    {
      for(i = 0; i < 3; i++)
       {
         a = 2;
         MPI_Send(&a, 1, MPI_INT, 0, 1, MPI_COMM_WORLD);
         printf("send to 0 in %d on 1\n",  omp_get_thread_num());
       
      } 
      
      for(i = 0; i < 3; i++)
      {
         MPI_Recv(&a, 1, MPI_INT, 0, 1,MPI_COMM_WORLD, MPI_STATUS_IGNORE);
         printf("recev from  0 in %d on 1\n",  omp_get_thread_num());
         
      }
    }
   if( rank==0 &&  (j ==1))
   {
       for(i = 0; i < 3; i++)
       {   
         MPI_Recv(&a, 1, MPI_INT, 1, 1, MPI_COMM_WORLD,MPI_STATUS_IGNORE);
         printf("recev from  1 in %d on 0\n",  omp_get_thread_num());
       }
      for(i = 0; i < 3; i++)
      {
           MPI_Send(&a, 1, MPI_INT, 1, 1,MPI_COMM_WORLD);
           printf("send to 1 in %d on 0\n",  omp_get_thread_num());
      }
   }
 // }  
}
 int testCFG = a + 1;

  #pragma omp parallel default(shared) private(iam, np)
  {
    np = omp_get_num_threads();
    iam = omp_get_thread_num();
     int tidp = omp_get_num_threads();
     tidp = tidp + 1;

    printf("Hello from thread %d out of %d from process %d out of %d on hongyi\n",
           iam, np, rank, numprocs);
  }

  MPI_Finalize();
}

